/*
    logViewer (for RoboCup-Rescue Project)
    Version 1.3.12 2001/04/14
    Copyright (C) 2000,2001 by Yoshitaka Kuwata
    Copyright (C) 2000,2001 by NTT DATA CORP.
    All rights reserved
 */

//package viewer;
import java.awt.*;
import java.io.*;

// CookedDataInoutStream
// This cleass is used only to swap byte read in from the stream 
class CookedDataInputStream extends DataInputStream {
    int b1, b2, b3, b4;
	
	// constructor
    public CookedDataInputStream(InputStream in) {
	super(in);
    }

    public int readCookedUnsigned() {
	read4byte();
	return ((b4 << 24) + (b3 << 16) + (b2 << 8) + b1); // swap byte order
    }

    public int readRawUnsigned() {
	read4byte();
	return((b1 <<24) + (b2 <<16) + (b3 <<16) + b4);
    }

    public int readCookedLong() {
	read4byte();
	int value = ((b4 & 0x7f) << 24) + (b3 << 16) + (b2 << 8) + b1;	// swap byte order
	if ((b4 & 0x80) == 0x80) {
	    value -= Integer.MAX_VALUE;	// complement
	}
	return value;		
    }

    public int readRawLong() {
	read4byte();
	int value = ((b1 & 0x7f) << 24) + (b2 <<16) + (b3 << 8) + b4;
	if ((b1 & 0x80) == 0x80) {
	    value -= Integer.MAX_VALUE;
	}
	return value;
    }

    void read4byte(){		// just read 4 byte form DataInputStream
	try {
	    b1 = in.read(); b2 = in.read(); b3 = in.read(); b4 = in.read();
	} catch (Exception e) {
	    System.err.println("Cannot read");
	}
    }
}

// EOF
